'use strict';

const co = require('co');

module.exports = (commands) => {
  if (!commands) return [];
  commands = Array.isArray(commands) ? commands : [commands];

  return co(function* () {
    let response = [];

    for (let i in commands) {
      const lastResponse = response.length ? response[response.length - 1] : null;
      try {
        response = response.concat(yield commands[i](lastResponse));
      } catch (ex) {
        return response.concat([ex]);
      }
    }

    return response;
  });
};
